#include <iostream>
#include <fstream>
#include <cstdlib>
#include <cmath>

#include "gg.h"
using namespace gg;

/*
** VF[_IuWFNg
*/
static GLuint shader1, shader2;
static GLint textureLoc, cubemapLoc;

/*
**gbN{[
*/
static GgTrackball *tb1, *tb2;
static int btn = -1;

/*
** 
*/
#include "Box.h"
static Box *box;

/*
** OBJ t@C
*/
static GLuint nv, nf;
static GLfloat (*vert)[3], (*norm)[3];
static GLuint (*face)[3];

/*
** eNX`
*/
#define TEXWIDTH  256                           /* eNX`̕@@@ */
#define TEXHEIGHT 256                           /* eNX`̍@@ */
static GLuint texname[2];                       /* eNX`iԍj */
static const char *texfile[] = {                /* eNX`t@C */
  "room3ny.tga", /*  */
  "room3nz.tga", /*  */
  "room3px.tga", /* E */
  "room3pz.tga", /* O */
  "room3nx.tga", /*  */
  "room3py.tga", /*  */
};
static const int target[] = {                /* eNX`̃^[Qbg */
  GL_TEXTURE_CUBE_MAP_NEGATIVE_Y,
  GL_TEXTURE_CUBE_MAP_NEGATIVE_Z,
  GL_TEXTURE_CUBE_MAP_POSITIVE_X,
  GL_TEXTURE_CUBE_MAP_POSITIVE_Z,
  GL_TEXTURE_CUBE_MAP_NEGATIVE_X,
  GL_TEXTURE_CUBE_MAP_POSITIVE_Y,
};

/*
** 
*/
static void init(void)
{
  /* OpenGL g@\̏ق */
  ggInit();

  /* OBJ t@C̓ǂݍ */
  ggLoadObj("bunny.obj", nv, vert, norm, nf, face, false);

  /* ̃IuWFNg𐶐 */
  box = new Box(500.0f, 500.0f, 500.0f);

  /* gbN{[pIuWFNg̐ */
  tb1 = new GgTrackball;
  tb2 = new GgTrackball;

  /* eNX`Q */
  glGenTextures(2, texname);
  
  /* eNX`摜̓[hPʂɋlߍ܂Ă */
  glPixelStorei(GL_UNPACK_ALIGNMENT, 4);

  /* Ỗ̗eNX`̊蓖āiWj */
  glBindTexture(GL_TEXTURE_2D, texname[0]);
  glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, TEXWIDTH * 8, TEXHEIGHT, 0,
    GL_RGBA, GL_UNSIGNED_BYTE, 0);
  
  /* eNX`摜̓ǂݍ */
  for (int i = 0; i < 6; ++i) {
    GLsizei width, height;
    GLenum format;
    GLubyte *image = ggLoadTga(texfile[i], width, height, format);

    if (image) {

      /* Ỗ̗eNX`̒u */
      glTexSubImage2D(GL_TEXTURE_2D, 0, TEXWIDTH * i, 0, TEXWIDTH, TEXWIDTH,
        format, GL_UNSIGNED_BYTE, image);

      /* L[u}bsÕeNX`̊蓖 */
      glBindTexture(GL_TEXTURE_CUBE_MAP, texname[1]);
      glTexImage2D(target[i], 0, GL_RGBA, TEXWIDTH, TEXWIDTH, 0, 
        format, GL_UNSIGNED_BYTE, image);

      /* ݒΏۂỖ̗eNX`ɖ߂ */
      glBindTexture(GL_TEXTURE_2D, texname[0]);
    }
  }
  
  /* eNX`gEk@̎w */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
  
  /* eNX`̌JԂ@̎w */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);

  /* ݒΏۂL[u}bsÕeNX`ɐ؂ւ */
  glBindTexture(GL_TEXTURE_CUBE_MAP, texname[1]);

  /* eNX`gEk@̎w */
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
  
  /* eNX`̌JԂ@̎w */
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
  
  /* ݒΏۂ𖳖eNX`ɖ߂ */
  glBindTexture(GL_TEXTURE_2D, 0);
  
  /* VF[_vO̍쐬 */
  shader1 = ggLoadShader("replace.vert", "replace.frag");
  shader2 = ggLoadShader("refract.vert", "refract.frag");
  
  /* eNX`jbg */
  textureLoc = glGetUniformLocation(shader1, "texture");
  cubemapLoc = glGetUniformLocation(shader2, "cubemap");

  /* ݒ */
  glClearColor(0.3f, 0.3f, 1.0f, 0.0f);
  glEnable(GL_DEPTH_TEST);
  glDisable(GL_CULL_FACE);
}

/*
** V[̕`
*/
static void scene(void)
{
  /* ݒΏۂỖ̗eNX`ɐ؂ւ */
  glBindTexture(GL_TEXTURE_2D, texname[0]);
  
  /* ̃eNX`̃VF[_vOKp */
  glUseProgram(shader1);
  glUniform1i(textureLoc, 0);

  /* ` */
  glPushMatrix();
  glMultMatrixf(tb2->get());
  box->draw();
  glPopMatrix();

  /* ݒΏۂL[u}bsÕeNX`ɐ؂ւ*/
  glBindTexture(GL_TEXTURE_CUBE_MAP, texname[1]);

  /* L[u}bsÕVF[_vOKp */
  glUseProgram(shader2);
  glUniform1i(cubemapLoc, 0);

  /* eNX`ϊsɃgbN{[̉] */
  glMatrixMode(GL_TEXTURE);
  glLoadTransposeMatrixf(tb2->get());
  glMatrixMode(GL_MODELVIEW);

  /* _菭ɃIuWFNg`ăgbN{[̉] */
  glPushMatrix();
  glTranslated(0.0, 0.0, -200.0);
  glMultMatrixf(tb1->get());

  /* _f[^C@f[^CeNX`W̔zLɂ */
  glEnableClientState(GL_VERTEX_ARRAY);
  glEnableClientState(GL_NORMAL_ARRAY);
  
  /* _f[^C@f[^CeNX`W̏ꏊw肷 */
  glNormalPointer(GL_FLOAT, 0, norm);
  glVertexPointer(3, GL_FLOAT, 0, vert);
  
  /* _̃CfbNX̏ꏊw肵Đ}``悷 */
  glDrawElements(GL_TRIANGLES, nf * 3, GL_UNSIGNED_INT, face);

  /* _f[^C@f[^CeNX`W̔z𖳌ɂ */
  glDisableClientState(GL_VERTEX_ARRAY);
  glDisableClientState(GL_NORMAL_ARRAY);

  glPopMatrix();
  
  /* eNX`ϊsɖ߂ */
  glMatrixMode(GL_TEXTURE);
  glLoadIdentity();
  glMatrixMode(GL_MODELVIEW);

  /* ݒΏۂ𖳖eNX`ɖ߂ */
  glBindTexture(GL_TEXTURE_2D, 0);
}


/****************************
** GLUT ̃R[obN֐ **
****************************/

static void display(void)
{
  /* ʃNA */
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  /* fr[ϊs̐ݒ */
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  
  /* V[̕` */
  scene();
  
  /* _uobt@O */
  glutSwapBuffers();
}

static void resize(int w, int h)
{
  /* gbN{[͈ */
  tb1->region(w, h);
  tb2->region(w, h);
  
  /* EBhEŜr[|[gɂ */
  glViewport(0, 0, w, h);
  
  /* ϊs̎w */
  glMatrixMode(GL_PROJECTION);
  
  /* ϊs̏ */
  glLoadIdentity();
  gluPerspective(60.0, (double)w / (double)h, 100.0, 500.0);
}

static void idle(void)
{
  /* ʂ̕`ւ */
  glutPostRedisplay();
}

static void mouse(int button, int state, int x, int y)
{
  btn = button;

  switch (btn) {
  case GLUT_LEFT_BUTTON:
    if (state == GLUT_DOWN) {
      /* gbN{[Jn */
      tb1->start(x, y);
      glutIdleFunc(idle);
    }
    else {
      /* gbN{[~ */
      tb1->stop(x, y);
      glutIdleFunc(0);
    }
    break;
  case GLUT_RIGHT_BUTTON:
    if (state == GLUT_DOWN) {
      /* gbN{[Jn */
      tb2->start(x, y);
      glutIdleFunc(idle);
    }
    else {
      /* gbN{[~ */
      tb2->stop(x, y);
      glutIdleFunc(0);
    }
    break;
  default:
    break;
  }
}

static void motion(int x, int y)
{
  switch (btn) {
  case GLUT_LEFT_BUTTON:
    /* gbN{[ړ */
    tb1->motion(x, y);
    break;
  case GLUT_RIGHT_BUTTON:
    /* gbN{[ړ */
    tb2->motion(x, y);
    break;
  default:
    break;
  }
}

static void keyboard(unsigned char key, int x, int y)
{
  switch (key) {
  case 'q':
  case 'Q':
  case '\033':
    /* ESC  q  Q ^CvI */
    exit(0);
  default:
    break;
  }
}

/*
** CvO
*/
int main(int argc, char *argv[])
{
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH | GLUT_DOUBLE);
  glutCreateWindow(argv[0]);
  glutDisplayFunc(display);
  glutReshapeFunc(resize);
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  glutKeyboardFunc(keyboard);
  init();
  glutMainLoop();
  return 0;
}
